package me.lensfrex.manager;

import me.lensfrex.manager.utils.Console;

public class Main {

    public static void main(String[] args) {
        new Main().run();
    }

    Worker worker = new Worker();

    Console consoleTool = new Console();

    private void run() {
        while (parseCommand(consoleTool.getUserInput()) != -1) {
            System.out.println(
                    "----------------------------------------------------------------\n" +
                            "    Please enter your choice:"
            );
        }
    }

    private int parseCommand(String command) {
        switch (command) {
            case "null":
            case "0":
                return -1;
            case "1":
                System.out.println(Worker.studentInformationExample);
                for (;;) {
                    String userInput = consoleTool.getUserInput();
                    if (userInput.equals(":wq")) {
                        break;
                    }
                    worker.addStudent(userInput);
                }
                break;
            case "2":
                System.out.println("Please enter the id or name of the student:");
                String userInput = consoleTool.getUserInput();

                System.out.println("Are you sure to delete \"" + userInput + "\"? (enter yes/no)");
                String sure = consoleTool.getUserInput();

                if (!sure.equals("yes")) {
                    break;
                }

                try {
                    long id = Long.parseLong(userInput);
                    worker.removeStudent(id);
                } catch (NumberFormatException e) {
                    worker.removeStudent(userInput);
                }
                break;
            case "3":
                worker.printAllSubjectInfo();
                break;
            case "4":
                worker.printAllStudentScoreInfo();
                break;
            case "5":
                worker.printRankingTable();
                break;
            case "6":
                worker.printScoreTableById();
                break;
            case "7":
                worker.printScoreTableByName();
                break;
            case "8":
            case "9":
                System.out.println("Please enter the id or name of the student: ");
                String input = consoleTool.getUserInput();
                try {
                    long id = Long.parseLong(input);
                    System.out.println(worker.searchById(id));
                } catch (NumberFormatException e) {
                    System.out.println(worker.searchByName(input));
                }
                break;
            case "10":
                System.out.println("Not support yet ：）");
                System.out.println("It will come out soon.");
                break;
            case "11":
                worker.listRecord();
                break;
            case "12":
                worker.printHelp();
                break;
            default:
                System.out.println("- Don't recognize... Please enter again. (Enter 12 to show help again)");
                break;
        }
        return 0;
    }
}
